/*
 * Copyright (C) 2013  Waritnan Sookbuntherng
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package tk.lion328.game.engine.coalsrc;

import org.lwjgl.util.vector.Vector2f;

import tk.lion328.game.engine.coalsrc.controller.KeyboardController;
import tk.lion328.game.engine.coalsrc.render3d.GameObjectManager;
import tk.lion328.game.engine.coalsrc.setting.Setting;
import tk.lion328.game.engine.coalsrc.ui.UIManager;
import tk.lion328.game.engine.coalsrc.util.TextureManager;

public abstract class GameApplication {
	
	private UIManager uiman = new UIManager();
	private UIManager uiIngame = new UIManager();
	private GameObjectManager objMan = new GameObjectManager();
	private Vector2f mapSize;
	private Setting setting;
	private KeyboardController keyboard;
	private TextureManager texman;
	
	public GameApplication(Vector2f mapSize, KeyboardController controller, Setting setting, TextureManager texman){
		this.mapSize = mapSize;
		keyboard = controller;
		this.setting = setting;
		this.texman = texman;
	}
	
	public void update(){
		
	}
	
	public final TextureManager getTextureManager(){
		return texman;
	}
	
	public final KeyboardController getKeyboardController(){
		return keyboard;
	}
	
	public final Vector2f getMapSize(){
		return mapSize;
	}
	
	public final Setting getSetting(){
		return setting;
	}
	
	public final void setUI(UIManager ui){
		ui = uiman;
	}
	
	public final UIManager getUI(){
		return uiman;
	}
	
	public final void clearUI(){
		uiman = new UIManager();
	}
	
	public final GameObjectManager getGameObjectManager(){
		return new GameObjectManager(objMan);
	}
	
	public void setGameObjectManager(GameObjectManager man){
		objMan = man;
	}
	
	public void setIngameUI(UIManager man){
		uiIngame = man;
	}
	
	public final UIManager getIngameUI(){
		return uiIngame;
	}
	
}
