/*
 * Copyright (C) 2013  Waritnan Sookbuntherng
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package tk.lion328.game.engine.coalsrc.render3d;

import org.lwjgl.util.vector.Vector3f;

public abstract class GameObject extends Object3D{

	public abstract Vector3f getCoordinate();
	public abstract boolean isSoild();
	public abstract Vector3f getStartPos();
	public abstract Vector3f getEndPos();
	
	public final Vector3f getCenterPos(){
		return new Vector3f(getStartPos().getX() + (getWidth() / 2),getEndPos().getY() + (getHeight() / 2),getStartPos().getZ() + (getLength() / 2));
	}
	public final float getWidth() {
		return getEndPos().getX() - getStartPos().getX();
	}
	public final float getHeight() {
		return getEndPos().getY() - getStartPos().getY();
	}
	public final float getLength() {
		return getEndPos().getZ() - getStartPos().getZ();
	}
	public final float getyTop() {
		return Math.abs(getEndPos().getY() - getStartPos().getY());
	}
	public final float getyBottom() {
		return getStartPos().getY() + getyTop() - getHeight();
	}
	
}
