/*
 * Copyright (C) 2013  Waritnan Sookbuntherng
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package tk.lion328.game.engine.coalsrc.render3d;

import java.util.HashMap;
import java.util.Map;

import org.lwjgl.util.vector.Vector3f;

public class GameObjectManager {
	
	private Map<Vector3f,GameObject> objs = new HashMap<Vector3f,GameObject>();
	
	public GameObjectManager(){}
	public GameObjectManager(GameObjectManager game){
		objs = game.objs;
	}
	
	public void addObject(GameObject o){
		if(objs.containsKey(o.getCoordinate())) objs.remove(o.getCoordinate());
		objs.put(o.getCoordinate(), o);
	}
	
	public void removeObject(Vector3f pos){
		if(objs.containsKey(pos)) objs.remove(pos);
	}
	
	public Map<Vector3f, GameObject> getObjectsList(){
		return new HashMap<Vector3f,GameObject>(objs);
	}
}
