/*
 * Copyright (C) 2013  Waritnan Sookbuntherng
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package tk.lion328.game.engine.coalsrc.ui;

import java.util.*;
import java.util.Map.Entry;

public class UIManager {
	
	private Map<String,UIObject> overlayUI = new HashMap<String,UIObject>();
	private Menu menu;
	
	public void setOverlayObject(String id,UIObject o){
		if(overlayUI.containsKey(id)) overlayUI.remove(id);
		overlayUI.put(id,o);
	}
	
	public UIObject getOverlayObject(String id){
		return overlayUI.containsKey(id) ? overlayUI.get(id) : null;
	}
	
	public void removeOverlayObject(String id){
		if(overlayUI.containsKey(id)) overlayUI.remove(id);
	}
	
	public void setMenu(Menu m){
		menu = m;
	}
	
	public Menu getMenu(){
		return menu;
	}
	
	public void update(){
		menu.update();
		for(Entry<String,UIObject> s : overlayUI.entrySet()){
			s.getValue().update();
		}
	}
	
	public void render(){
		menu.render();
		for(Entry<String,UIObject> s : overlayUI.entrySet()){
			s.getValue().render();
		}
	}
	
	public Map<String,UIObject> getOverlayObjectsList(){
		return new HashMap<String,UIObject>(overlayUI);
	}
}
